//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class Immeuble: JSONDecodable, JSONEncodable, PrettyPrintable {

    public var adresse: String?

    public var id: Int?

    public var latitude: String?

    public var longitude: String?

    public init(adresse: String? = nil, id: Int? = nil, latitude: String? = nil, longitude: String? = nil) {
        self.adresse = adresse
        self.id = id
        self.latitude = latitude
        self.longitude = longitude
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        adresse = jsonDictionary.json(atKeyPath: "adresse")
        id = jsonDictionary.json(atKeyPath: "id")
        latitude = jsonDictionary.json(atKeyPath: "latitude")
        longitude = jsonDictionary.json(atKeyPath: "longitude")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let adresse = adresse {
            dictionary["adresse"] = adresse
        }
        if let id = id {
            dictionary["id"] = id
        }
        if let latitude = latitude {
            dictionary["latitude"] = latitude
        }
        if let longitude = longitude {
            dictionary["longitude"] = longitude
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
